﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LifeLogApp.Model
{
    public class LifeLogEvent
    {
        // https://business.adobe.com/blog/basics/project-management-101-the-5-ws-and-1-h-that-should-be-asked-of-every-project
        // When did it take place?
        // Where  did it take place?
        // What happened?
        // Who  is it about?
        // Why did it happen?

        public Guid Id { get; set; }

        public DateTime WhenOrTime { get; set; }
        public Location WhereOrPlace { get; set; }
        public string WhatOrEventOrHowOrAction { get; set; }

        public string WhoOrUserOrEmail { get; set; }

        public string Why { get; set; }

        public string FolderOrProject { get; set; }

        public List<string> Tags { get; set; }

        public string LocalMediaFileName { get; set; }
        public bool LocalMediaIsRotatedOrPostFixed { get; set; }
        public DateTime LocalMediaIsUploaded { get; set; }

        public string ShortFileName => LocalMediaFileName.Substring(LocalMediaFileName.Length - 20);

        public string MediaType => Path.GetExtension(LocalMediaFileName);

        public DateTime WhenOrLocalTime => WhenOrTime.ToLocalTime();
    }
}
