﻿using LifeLogApp.Interfaces;
using System.Reflection;

namespace LifeLogApp;

public partial class MainPage : ContentPage
{
    private Serilog.ILogger logger;

    int count = 0;

    public MainPage(Serilog.ILogger logger, IAppDeviceInfo getDeviceInfo)
    {
        this.logger = logger;

        InitializeComponent();

        Title = AppInfo.Current.VersionString;
        lblInfo.Text = getDeviceInfo.GetDeviceID();
    }

    private void OnCounterClicked(object sender, EventArgs e)
    {
        count++;

        logger.Debug("Serilog Test: {Time}: Click Count {Count}", DateTime.Now, count);

        MainThread.BeginInvokeOnMainThread(() =>
        {
            if (count == 1)
                CounterBtn.Text = $"Clicked {count} time";
            else
                CounterBtn.Text = $"Clicked {count} times";
        });
    }

    private async void OnNavigateToNewPage1(object sender, EventArgs e)
    {
        await Shell.Current.GoToAsync(nameof(NewPage1), true, new Dictionary<string, object>() { { "title", "Shell.Current.GoToAsync" } });
    }

    private async void OnNavigateToTabCapture(object sender, EventArgs e)
    {
        await Shell.Current.GoToAsync($"//{nameof(CapturePage)}");
    }
}

