using LifeLogApp.Classes;
using LifeLogApp.Services;
using Microsoft.AppCenter.Analytics;
using RestSharp;

namespace LifeLogApp;

public partial class TakePhoto : ContentPage
{
    private Serilog.ILogger logger;

    public TakePhoto(Serilog.ILogger logger)
    {
        this.logger = logger;

        InitializeComponent();
    }

    private async void OnBtnTakePhotoClicked(object sender, EventArgs e)
    {
        await TakePhotoAsync();
        lblPhotoUploadPath.Text = AppHelper.AppPathUploadEvents;
    }

    async Task TakePhotoAsync()
    {
        await MainThread.InvokeOnMainThreadAsync(async () =>
        {
            // https://docs.microsoft.com/en-us/dotnet/maui/platform-integration/device-media/picker?tabs=android
            var photoFile = await MediaHelper.TakePhotoAsync();
            if (photoFile != null)
            {
                imgLast.Source = photoFile;
                lblPathLastPhoto.Text = photoFile;
                logger.Debug("Photo {File}", photoFile);
                //Analytics.TrackEvent("TakePhotoAsync", new Dictionary<string, string> { { "photoFile", photoFile } });
                //for (int i = 0; i < 10; i++)
                //{
                //    File.Copy(photoFile, Path.Combine(AppService appService.AppPathUploadEvents, $"{Guid.NewGuid()}{Path.GetExtension(photoFile)}"));
                //}
            }
            else
            {
                logger.Error("No Camera");
                await DisplayAlert("Error", "No Camera", "Ok");
            }
        });
    }
}