using LifeLogApp.Classes;
using LifeLogApp.Services;
using RestSharp;
using Method = RestSharp.Method;

namespace LifeLogApp;

public partial class TakeVideo : ContentPage
{    
    public TakeVideo()
    {
        InitializeComponent();
    }

    private async void OnBtnTakeVideoClicked(object sender, EventArgs e)
    {
        await TakeVideoAsync();
        lblVideoUploadPath.Text = AppHelper.AppPathUploadEvents;
    }

    async Task TakeVideoAsync()
    {
        await MainThread.InvokeOnMainThreadAsync(async () =>
        {
            // https://docs.microsoft.com/en-us/dotnet/maui/platform-integration/device-media/picker?tabs=android
            var VideoPath = await MediaHelper.TakeVideoAsync();
            if (VideoPath != null)
            {
                imgLast.Source = VideoPath;
                lblPathLastVideo.Text = VideoPath;
            }
            else
            {
                await DisplayAlert("Error", "No Camera", "Ok");
            }
        });
    }
}