﻿using LifeLogApp.Classes;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;

namespace LifeLogApp.Services
{
    public class ConnectivityService
    {
        Serilog.ILogger logger;

        public ConnectivityService(Serilog.ILogger logger)
        {
            this.logger = logger;

            logger.Verbose("{Method}: Start", AppHelper.BuildFullMethodName(MethodBase.GetCurrentMethod()));

            logger.Debug("NetworkAccess has chaged to {NetworkAccess}", Connectivity.Current.NetworkAccess.ToString());

            foreach (var item in Connectivity.Current.ConnectionProfiles)
            {
                logger.Debug("ConnectivityChanged: ConnectionProfile={ConnectionProfiles}", item.ToString());
            }

            Connectivity.ConnectivityChanged += Connectivity_ConnectivityChanged;
        }

        void Connectivity_ConnectivityChanged(object sender, ConnectivityChangedEventArgs e)
        {
            logger.Debug("NetworkAccess has chaged to {NetworkAccess}", e.NetworkAccess.ToString());

            // Log each active connection
            foreach (var item in e.ConnectionProfiles)
            {
                logger.Debug("ConnectivityChanged: ConnectionProfile={ConnectionProfiles}", item.ToString());
            }
        }
    }
}
